package com.ontestautomation.testnet.exercises;

import static com.jayway.restassured.RestAssured.given;
import static org.hamcrest.Matchers.*;

import org.testng.annotations.BeforeClass;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.Test;

import com.jayway.restassured.RestAssured;

public class RestAssuredExercises4 {
	
	/*******************************************************
	 * Vraag een authenticatietoken aan bij de PayPal sandbox
	 * API en schrijf de response naar de console
	 * Gebruik Basic authentication
	 * username = AUyqLmmlHyX4Th7BdXpIN-sKu5rARNpWLNtQZabRneRp5eDrKEU5pdiNIOMgc-4OiNu4jX8VJwfwWr1a
	 * password = ECFXJmz2yW0WDf0itUE13jgaBhLkF5kEV9pyzt8iK9vvWgoSBRQ0HCywNIqYftSwXmB6EH_KOGq0nO39
	 * https://api.sandbox.paypal.com/v1/oauth2/token
	 * Sla het access token op in een string, zodat we deze
	 * in latere tests kunnen gebruiken
	 ******************************************************/
	
	String accessToken;
	
	@BeforeClass
	public void retrieveOAuthToken() {
		
		accessToken = 
		
		given().
			parameters("grant_type","client_credentials").
			auth().
			preemptive().
			basic("AUyqLmmlHyX4Th7BdXpIN-sKu5rARNpWLNtQZabRneRp5eDrKEU5pdiNIOMgc-4OiNu4jX8VJwfwWr1a","ECFXJmz2yW0WDf0itUE13jgaBhLkF5kEV9pyzt8iK9vvWgoSBRQ0HCywNIqYftSwXmB6EH_KOGq0nO39").
		when().
			post("https://api.sandbox.paypal.com/v1/oauth2/token").
		then().
			extract().
			path("access_token");
	}
	
	/*******************************************************
	 * Vraag de lijst met betalingen op voor dit account en
	 * controleer dat het aantal betalingen gelijk is aan 0.
	 * Gebruik OAuth2 authenticatie icm het eerder opgehaalde
	 * token
	 * https://api.sandbox.paypal.com/v1/payments/payment/
	 ******************************************************/
	
	@Test
	public void checkNumberOfPayments() {
		
		given().
			auth().
			oauth2(accessToken).
		when().
			get("https://api.sandbox.paypal.com/v1/payments/payment/").
		then().
			assertThat().
			body("count",equalTo(0));
	}
}
